# Aliases

Defined in [aliases.bash](/bash/aliases.bash)

**`quit`**

*Exit a process.* Apple likes the word 'quit' rather than exit, though Bash has
`exit` and `logout`.

**`ls`**

*Format and colorize `ls`.* Come on. It just looks prettier.

**`lsa`**

*`ls` with hidden files.* Sh. It's a secret to everybody.

**`ll`**

*Long `ls` file listing.* Sometimes longer is better.

**`lla`**

*Long `ls` file listing with hidden files.* Too much?

**`lh`**

*Long `ls` file listing with human readable sizes.* What is 132873 B again?

**`lha`**

*Long `ls` file listing with hidden files and human-readable sizes.* No, that
wasn't short, and yes, hopefully you've caught on by now.

**`cp`**

*Verbose; confirm overwrites.* My copier talks to me.

**`mv`**

*Verbose; confirm overwrites.* So does my moving truck.

**`mkdir`**

*Verbose; create intermediate directories.* Can't build without a foundation.

**`rm`**

*Interactive (confirm deletes).* Don't delete the wrong things without the
Force.

**`hidden`**

*Show only hidden files.* They're usually hidden for a reason.

**`cd..`**

*Go up a directory level.* Prefer `..`. It's shorter.

**`..`**

*Go up a directory level.* If confused, see `cd..`.

**`~`**

*Go home.* Do not pass Go, do not collect $200.

**`edit`**

*Open a file(s) in Vim.* Because what else are you doing when you `edit`?

**`explore`**

*Browse the current working directory in Vim.* Explore! Be free! Maps may be necessary and can be
accessed with `<F1>`.

**`finder`**

*Open the current working directory in Finder.* Did you get lost?

**`app`**

*Open an application.* Not an appetizer.

**`updateDotfiles`**

*Update the Dotfiles.* ...

**`starwars`**

*Watch Star Wars.* A long time ago in a galaxy inside your terminal...

**`beep`**

*Your Terminal beeps.* Beep beep.

**`today`**

*Output the date.* There's always tomorrow.

**`battery`**

*Display battery information.* Don't die!

**`lvim`**

*Open your last vim position.* Because you needed *another* way to invoke vim.

**`screensaver`**

*SOS: Save our screen!*
